/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRSUBGRPROD                                              */
/* Tabela : PRSUBGRPROD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 26/06/2007 - FELIPE HENRIQUE                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRSUBGRPROD'and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRSUBGRPROD
GO

CREATE TRIGGER DTULTATU_PRSUBGRPROD
ON PRSUBGRPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       (SELECT 'PRSUBGRPROD', NULL, 'CDGRUPPROD=' + CDGRUPPROD +';'+ 'CDSUBGRPROD=' + CDSUBGRPROD +
                       ';'+ 'CDPRODUTO=' + CDPRODUTO +';'+ 'CDFILISUBGR='+ CDFILISUBGR +';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
   END
   ELSE BEGIN
      UPDATE PRSUBGRPROD
      SET DTULTATUPRSUBGR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PRSUBGRPROD.CDGRUPPROD,0) = ISNULL(INSERTED.CDGRUPPROD,0))AND
            (ISNULL(PRSUBGRPROD.CDSUBGRPROD,0)= ISNULL(INSERTED.CDSUBGRPROD,0))AND
            (ISNULL(PRSUBGRPROD.CDPRODUTO,0)  = ISNULL(INSERTED.CDPRODUTO,0))AND
            (ISNULL(PRSUBGRPROD.CDFILISUBGR,0)= ISNULL(INSERTED.CDFILISUBGR,0));
   END;
END;
GO

UPDATE PRSUBGRPROD SET DTULTATUPRSUBGR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPRSUBGR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPRSUBGR' and
            type = 'D')
   ALTER TABLE PRSUBGRPROD DROP CONSTRAINT DEFAULT_DTULTATUPRSUBGR
GO

ALTER TABLE PRSUBGRPROD ADD CONSTRAINT DEFAULT_DTULTATUPRSUBGR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPRSUBGR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRSUBGRPROD','4.11.194';
GO

